<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class StockAdjustment extends BaseModel
{
    use HasFactory;

    protected $guarded = [];


    protected static function boot()
    {
        parent::boot(); // always call the parent boot
        static::addGlobalScope('typeScope', function ($builder) {
            if (auth()->check() && auth()->user()->shop_id != null) {
                $shopId = auth()->user()->shop_id;

                $builder->Where(function ($query) use ($shopId) {
                    $query->where('stock_adjustments.transition_location_id', $shopId)
                        ->orWhere('stock_adjustments.location_id', $shopId);
                });
            }
        });
        static::creating(function ($model) {
            if (auth()->check()) {
                $user = auth()->user();
                $model->transition_location_id = $user->shop_id;
                $model->transition_create_by = $user->id;
            }
        });

        static::updating(function ($model) {
            if (auth()->check()) {
                $model->transition_update_by = auth()->id(); // use user ID here
            }
        });
    }
    public function details()
    {

        return $this->hasMany(StockAdjustmentDetails::class)->with('product', 'attribute');
    }

    public function warehouse()
    {
        return $this->belongsTo(Warehouse::class,'location_id');
    }

}
